## Type of Ports
Well known ports ranges                                     --->          0 -   1023
Register port ranges                                            --->    1024 -  49151
Dynamic port ranges (Temporary port)              ---> 49152 - 65535 

## Port Table

| Port Number | Service       | Description                                     | Exploit                           | Link         |
| ----------- | ------------- | ----------------------------------------------- | --------------------------------- | --------- |
| 20          | FTP           |                                                 |                                   | [[• FTP]]    |
| 21          | SFTP          |                                                 |                                   | [[• FTP]]    |
| 22          | SSH           | SSH Encrypted Shell                             | Brute Force                       | [[• SSH]]    |
| 23          | Telnet        |                                                 |                                   | [[• Telnet]] |
| 25          | SMTP          | Simple Mail Transfer Protocol                   |                                   | [[• SMTP]]   |
| 53          | DNS           | Domain Name System                              |                                   | [[• DNS]]    |
| 67          | DHCP (Server) | Dynamic Host Configuration Protocol             |                                   |              |
| 68          | DHCP (Client) | Dynamic Host Configuration Protocol             |                                   |              |
| 69          | TFTP          | Trivial File Transfer Protocol                  |                                   |              |
| 80          | HTTP          | Hypertext Transfer Protocol (Server)            |                                   |              |
| 88          | Kerberos      |                                                 |                                   |              |
| 110         | POP3          | Post Office Protocol V.3                        |                                   | [[• POP3]]   |
| 111         | NSF           | Network File System                             | Mounting Vulnerable Shared Folder | [[• NSF]]    |
| 135         | MSRPC         |                                                 |                                   | [[• MSRPC]]  |
| 137         | NetBIOS       | Network Basic Input/Output System (Legacy)      |                                   |              |
| 139         | NetBIOS       | Network Basic Input/Output System (Legacy)      |                                   |              |
| 143         | IMAP          |                                                 |                                   | [[• IMAP]]   |
| 161         | SNMP          | Simple Network Management Protocol              |                                   |              |
| 162         | SNMP          | Simple Network Management Protocol              |                                   |              |
| 389         | LDAP          | Lightweigth Directory Application Protocol (AD) |                                   | [[• LDAP]]   |
| 443         | HTTPS         | Hypertext Transfer Protocol Secure (Server)     |                                   |              |
| 445         | SMB           | Server Message Block                            |                                   | [[• SMB]]    |
| 587         | SMPT          |                                                 |                                   | [[• SMTP]]   |
| 636         | SSL LDAP      | SSL LDAP authentification in Active Directory   |                                   | [[• LDAP]]   |
| 993         | IMAPS         |                                                 |                                   |              |
| 995         | POP3S         |                                                 |                                   |              |
| 1433        | MYSQL         | MYSQL database                                  |                                   | [[• MySQL]]  |
| 1434        | MYSQL         | MYSQL database                                  |                                   | [[• MySQL]]  |
| 1723        | PPTP          |                                                 |                                   |              |
| 3026        | RDP           | Remote Desktop Protocol                         | Brute Force                       | [[• RDP]]    |
| 3306        | SQL Database  | Microsoft or MYSQL database                     |                                   | [[• MySQL]]  |
| 3389        | RDP           | Remote Desktop Protoco                          | Brute Force                       | [[• RDP]]    |
| 5060        | VoIP          | Session Initial Protocol                        |                                   |              |
| 5900        | VNC           | Virtual Network Computing                       | Brute Force                       | [[• VNC]]    |
| 8080        | HTTPS         | Hypertext Transfer Protocol Secure (Server)     |                                   |              |
|             |               |                                                 |                                   |              |
