
## What is Server-Side Request Vulnerability

Server-Side Request Forgery (SSRF) is a type of web application vulnerability that allows an attacker to send a crafted request from a vulnerable server to a different internal or external resource. The attacker can access restricted resources, such as internal network services, that are not meant to be exposed to the attacker. The vulnerability is caused by a lack of proper validation and sanitization of user-supplied input, which can be used to manipulate the request sent by the server. This type of attack can lead to information disclosure, access to restricted functionality, and even potential Remote Code Execution.

- Example of SSRF
	A web application allows users to upload an image to the server, but it does not properly validate the image URL. An attacker can craft a malicious image URL that points to an internal IP address or a private resource, such as an internal server or a database. When the server tries to download the image, it sends a request to the internal IP address or private resource, potentially exposing sensitive information or allowing the attacker to access restricted resources.