
## What is Whatweb

WhatWeb is a tool that is used to identify the technologies being used on a website. It can be used to scan a single website or a list of websites, and it will try to identify the web server software, the content management system, and any JavaScript libraries or frameworks that are being used.

In addition to identifying the technologies being used, WhatWeb can also display information about the structure of the website. For example, it can show the route through the website, including any redirections that are in place. This can be useful for understanding how a website is organized and how it functions.

WhatWeb is written in Ruby and is distributed as a command-line tool. It can be used on its own or in combination with a variety of plugins, which can be used to identify specific technologies or gather additional information about the website.

Commands
```
whatweb DOMAIN
```

- Example of output:
    
    
    
    
    
    
    
    ```
	http://biblio.shawinigan.ca [302 Found] Country[CANADA][CA], HTTPServer[nginx/1.6.2], IP[206.47.87.235], RedirectLocation[https://biblio.shawinigan.ca/], Title[302 Found], nginx[1.6.2]
	
	https://biblio.shawinigan.ca/ [302 Found] Country[CANADA][CA], HTTPServer[nginx/1.6.2], IP[206.47.87.235], RedirectLocation[https://biblio.shawinigan.ca/in/], nginx[1.6.2]
	
	https://biblio.shawinigan.ca/in/ [302 Found] Cookies[JSESSIONID], Country[CANADA][CA], HTTPServer[nginx/1.6.2], HttpOnly[JSESSIONID], IP[206.47.87.235], Java, RedirectLocation[https://biblio.shawinigan.ca/in/faces/index.xhtml], nginx[1.6.2]
	 
	https://biblio.shawinigan.ca/in/faces/index.xhtml [200 OK] Cookies[JSESSIONID], Country[CANADA][CA], HTTPServer[nginx/1.6.2], HttpOnly[JSESSIONID], IP[206.47.87.235], Java, Script[text/javascript], Title[Bienvenue], nginx[1.6.2]
	
	```



## More information

More Information ---> https://github.com/urbanadventurer/WhatWeb

