
## General

A vulnerability in a service can often be related to the version of the service that is installed on a system. For example, a particular version of a service may have a security flaw that was discovered and fixed in a later version of the service. If a system is running an older, vulnerable version of the service, it may be at risk of being exploited.

It is important to keep the versions of all services on a system up to date in order to minimize the risk of vulnerabilities. By regularly updating the services to the latest version, you can ensure that any known vulnerabilities are patched and that your system is as secure as possible.

There are several ways to update the services on a system, depending on the specific service and the version of Linux you are using. Some common methods for updating services include using package management tools (such as `apt-get` or `yum`), downloading and installing updates from the service's website, or using a software update tool provided by the Linux distribution.


## Commands

1. List the services installed on the machine
```
systemctl list-units --type=service --all
SERVICE -v or version            ---> Display the version of the application
```

2. Find an exploit
```
Exploit for X version X          ---> On Google
```

2. Run the exploit
```
./service_exploit.sh
```